/*


    azpartic.c

    particlefx

*/


#include    "azpartic.h"
#include    "g_main.h"
#include    "m_main.h"

#include    <math.h>

#define gfakepnum 4096
static particle2d gfparts[gfakepnum];

void *init_gfake (void *dat,cbitmap *s ,cbitmap *d ,int duration) {
int i;
int e=0;
tGfakeData *er=(tGfakeData*)dat;

    for (i=0;i<(er->parnum>>1);i++) {

        gfparts[e].vx=(((float)(i&0x1f))*(1.0/16.0))-1;
        gfparts[e].vy=(((float)((i>>5)&0x1f))*(1.0/16.0))-1;

        gfparts[e].x=100;
        gfparts[e].y=20;

        gfparts[e++].color=((i>>2)&0x3);

        }

    for (i=0;i<(er->parnum>>1);i++) {

        gfparts[e].vx=(((float)(i&0x1f))*(1.0/16.0))-1;
        gfparts[e].vy=(((float)((i>>5)&0x1f))*(1.0/16.0))-1;

        gfparts[e].x=210;
        gfparts[e].y=60;

        gfparts[e++].color=((i>>2)&0x3);

        }

    return (void*)dat;
    }

void  doit_gfake (void *in,cbitmap *s1,cbitmap *s2,cbitmap *d,int time,int duration) {
int i;
short x,y;
short xsiz,ysiz;

tGfakeData *dat=(tGfakeData*)in;

int *tta=(int*)d->data;
int *tta2;
int ta,tb,tc;

float   dex,dey;

float   xd,yd,rezlen,len;

float  t;
float  grav,damp;

    t=(float)time;

    dex=160+dat->xamp*((float)sin((2.0*3.14/1000000.0*dat->xspeed)*t));
    dey= 64+dat->yamp*((float)cos((2.0*3.14/1000000.0*dat->yspeed)*t));

    damp=dat->damping;
    grav=dat->grav;

    // Process particles
    if (damp!=1) {
        for (i=0; i<dat->parnum; i++) {

            xd=dex-gfparts[i].x;
            yd=dey-gfparts[i].y;
            len=(xd*xd+yd*yd)*grav;
            if  (len==0) len=0.00001;

            rezlen=1/len;

            gfparts[i].vx+=xd*rezlen;
            gfparts[i].vy+=yd*rezlen;

            gfparts[i].vx*=damp;
            gfparts[i].vy*=damp;

            gfparts[i].x+=gfparts[i].vx;
            gfparts[i].y+=gfparts[i].vy;

            }
        }
    else
        {

        for (i=0; i<dat->parnum; i++) {

            xd=dex-gfparts[i].x;
            yd=dey-gfparts[i].y;
            len=(xd*xd+yd*yd)*grav;
            if  (len==0) len=0.00001;

            rezlen=1/len;

            gfparts[i].vx+=xd*rezlen;
            gfparts[i].vy+=yd*rezlen;

            gfparts[i].x+=gfparts[i].vx;
            gfparts[i].y+=gfparts[i].vy;

            }

    }



    // Draw particles

    xsiz=(short)d->x-3;
    ysiz=(short)d->y-2;


    if  (d->bpp==18) {
        for (i=0; i<dat->parnum;i++) {
            x=(short)gfparts[i].x;
            y=(short)gfparts[i].y;
            if ((((unsigned short)x)<(xsiz<<1))&&(((unsigned short)y)<ysiz)) {
				// Bad C-Hack !

            tta2=tta+y*(xsiz+3)+(x>>1);
            switch (gfparts[i].color) {

            case 0:
                     ta=*tta2+0x00080800;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x04101004;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x00080800;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     tta2+=xsiz;

                     ta=*tta2+0x00101000;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x18202018;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x00101000;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     tta2+=xsiz;

                     ta=*tta2+0x00080800;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x04101004;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x00080800;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     break;
            case 1:
                     ta=*tta2+0x08080008;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x10100010;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x08080008;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     tta2+=xsiz;

                     ta=*tta2+0x10100010;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x20201820;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x10100010;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     tta2+=xsiz;

                     ta=*tta2+0x08080008;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x10100410;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x08080008;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     break;

            case 2:
                     ta=*tta2+0x08000808;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x10001010;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x08000808;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     tta2+=xsiz;

                     ta=*tta2+0x10001010;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x20182020;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x10001010;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     tta2+=xsiz;

                     ta=*tta2+0x08000808;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x10041010;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x08000808;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     break;

            case 3:
                     ta=*tta2+0x00000800;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x00001000;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x00000800;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     tta2+=xsiz;

                     ta=*tta2+0x00001000;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x18182018;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x00001000;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     tta2+=xsiz;

                     ta=*tta2+0x00000800;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x04041004;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     ta=*tta2+0x00000800;
                     tb=ta&0x40404040;
                     tc=tb>>6;
                     tb-=tc;
                     *tta2++=(ta|tb)&0x3f3f3f3f;

                     break;


                     }
                }
            }
        }
    }

void  exit_gfake (void *dat) {

    }


int     tlast=0;

